// Solutions to the Advent Of Code 2024.
// Copyright (C) 2025  Stefan Müller
//
// This program is free software: you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation, either version 3 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along with
// this program.  If not, see <http://www.gnu.org/licenses/>.

#pragma once

#include <map>
#include <vector>

#include <aoc/framework/Solver.hpp>

class PlutonianPebbles : public Solver
{
public:
    virtual const std::string getPuzzleName() const override;
    virtual const int getPuzzleDay() const override;
    virtual void processDataLine(const std::string& line) override;
    virtual void finish() override;
private:
    static constexpr int getNBlinksPart1();
    static constexpr int getNBlinksPart2();
    std::map<long long int, std::vector<long long int>> blinkMap_{};
    void addPebble(std::map<long long int, long long int>& pebbles, const long long int pebbleNumber,
        long long int cardinality);
    void addNextBlinkNumbers(const long long int pebbleNumber, std::vector<long long int>& nextBlinkNumbers);
    int getNNextBlinkNumbers(const long long int pebbleNumber) const;
};
