// Solutions to the Advent Of Code 2024.
// Copyright (C) 2025  Stefan Müller
//
// This program is free software: you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation, either version 3 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along with
// this program.  If not, see <http://www.gnu.org/licenses/>.

#pragma once

#include <string>
#include <vector>

#include <aoc/common/Lines.hpp>
#include <aoc/common/Point2.hpp>

class WarehouseBoxPusher
{
public:
    WarehouseBoxPusher(const char boxChar, const char wallChar, const char emptyChar);
    virtual ~WarehouseBoxPusher(){};
    virtual void processMovements(Lines& warehouseMap, const std::string& line);
    virtual void processMovement(Lines& warehouseMap, const Point2& direction);
    void setRobotPosition(const Point2& robotPosition);
protected:
    Point2 robotPosition_;
    const char boxChar_;
    const char wallChar_;
    const char emptyChar_;
};
