// Solutions to the Advent Of Code 2024.
// Copyright (C) 2024-2025  Stefan Müller
//
// This program is free software: you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation, either version 3 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along with
// this program.  If not, see <http://www.gnu.org/licenses/>.

#include <aoc/common/Lines.hpp>

#include <algorithm>

bool Lines::isInBounds(const Point2& point) const
{
    return 0 <= point.y && point.y < size() &&
        0 <= point.x && point.x < at(point.y).size();
}

char Lines::getCharAt(const Point2& point) const
{
    return at(point.y)[point.x];
}

void Lines::setCharAt(const Point2& point, const char value)
{
    at(point.y)[point.x] = value;
}

std::ostream& operator<<(std::ostream& os, const Lines& lines)
{
    for (const auto& line : lines)
    {
        os << line << std::endl;
    }
    return os;
}
