// Solutions to the Advent Of Code 2024.
// Copyright (C) 2024  Stefan Müller
//
// This program is free software: you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation, either version 3 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along with
// this program.  If not, see <http://www.gnu.org/licenses/>.

#include <aoc/extra/MullEntryState.hpp>

void MullEntryState::enter(StringStateMachine* stateMachine)
{
    next(stateMachine);
}

void MullEntryState::next(StringStateMachine* stateMachine)
{
    if (stateMachine->getCurrent() == 'm')
    {
        stateMachine->setState(*mulState_);
    }
    else if (stateMachine->getCurrent() == 'd')
    {
        stateMachine->setState(*doState_);
    }
}

void MullEntryState::setTransitions(StringState& mulState, StringState& doState)
{
    mulState_ = &mulState;
    doState_ = &doState;
}
